<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper non-table">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="6" class="text-align-left">
                            <h3>My Histories</h3>
                        </el-col>
                        <el-col :span="18">
                            <el-row :gutter="20">
                                <el-col :lg="19" :md="19" :sm="24">
                                    <el-date-picker
                                        prop="daterange"
                                        ref="daterange"
                                        name="daterange"
                                        v-model="filter.daterange"
                                        type="daterange"
                                        align="right"
                                        unlink-panels
                                        range-separator="To"
                                        start-placeholder="Start date"
                                        end-placeholder="End date"
                                        :clearable="true" 
                                        :editable="false">
                                    </el-date-picker>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getMyHistories(1, false)" size="medium" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>            
                </div>
                <div class="block text-align-left" v-loading="historyLoading">
                    <el-timeline v-if="histories.length > 0" v-infinite-scroll="loadMore">
                        <el-timeline-item
                            v-for="(history, index) in histories"
                            :key="index" 
                            :timestamp="dateFormat(history.created)" 
                            placement="top">
                            <el-card>
                                <h4>{{ history.user.fullname }} - {{ history.action }} {{ history.module }}</h4>
                                <p>{{ history.user_agent.os.family }} {{ history.user_agent.os.major }} {{ history.user_agent.user_agent.family }} - {{ history.remote_address }}</p>
                                <code v-if="Object.keys(history.content).length > 0">{{ JSON.stringify(history.content, null, 4) }}</code>
                            </el-card>
                        </el-timeline-item>                        
                    </el-timeline>
                    <el-row v-else :gutter="20" type="flex" justify="center" align="middle" :style="`height:${tableHeight()}px;`">
                        <el-col :lg="24" :md="24" :sm="24" align="middle">
                            <div class="no-content text-align-center">
                                <i class="ion-ios-time" style="font-size:100px;color:#909399;"></i>
                                <span class="display-block">No Histories Recorded</span>
                            </div>
                        </el-col>
                    </el-row>
                </div>
            </el-col>
        </el-row>
    </div>
</template>

<script>
import { mapGetters } from 'vuex';
import { dateFormat, tableHeight } from '../../utils/index';
export default {
    name: 'MyHistories',
    data(){
        return{
            historyLoading: true,
            filter: {
                daterange: null
            }
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('history', [
            'histories',
            'pagination'
        ])  
    },
    created(){
        const self = this;
        self.getMyHistories(1, false);
    },
    methods: {
        dateFormat,
        tableHeight,
        getMyHistories(page, loadmore){
            const self = this;

            self.historyLoading = true;

            let params = {
                user: self.user.id,
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only: 'action,content,module,remote_address,created,user.fullname,user_agent'
            };
            if(self.filter.daterange != null){
                params.daterange = self.filter.daterange.map((x)=>dateFormat(x, 'YYYY-MM-DD')).join(',');
            }

            self.$store.dispatch('history/getHistories', params).then(()=>{
                self.historyLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getMyHistories(self.pagination.page + 1, true);
            }
        }
    },
    
}
</script>